void factor_calc (const struct ccase *c, int case_no,
- double weight, int case_missing);
+ double weight, bool case_missing);
/* Represent a factor as a string, so it can be
/* Perform calculations for the sub factors */
void
factor_calc (const struct ccase *c, int case_no, double weight,
- int case_missing)
+ bool case_missing)
{
size_t v;
struct factor *fctr = factors;
if (case_missing || var_is_value_missing (var, val, exclude_values))
{
free (val);
- continue;
+ val = NULL;
}
metrics_calc ( & (*foo)->m[v], val, weight, case_no);
for (; casereader_read (input, &c); case_destroy (&c))
{
- int case_missing = 0;
+ bool case_missing = false;
const double weight = dict_get_case_weight (dict, &c, NULL);
if ( cmd->miss == XMN_LISTWISE )
);
if ( var_is_value_missing (var, val, exclude_values))
- case_missing = 1;
+ case_missing = true;
free (val);
}
|| case_missing )
{
free (val) ;
- continue ;
+ val = NULL;
}
metrics_calc (&totals[v], val, weight, case_no);
tab_title (tbl, _ ("Case Processing Summary"));
-
tab_joint_text (tbl, heading_columns, 0,
n_cols -1, 0,
TAB_CENTER | TAT_TITLE,
for ( i = 0 ; i < 3 ; ++i )
{
- tab_text (tbl, heading_columns + i*2 , 2, TAB_CENTER | TAT_TITLE,
+ tab_text (tbl, heading_columns + i * 2 , 2, TAB_CENTER | TAT_TITLE,
_ ("N"));
- tab_text (tbl, heading_columns + i*2 + 1, 2, TAB_CENTER | TAT_TITLE,
+ tab_text (tbl, heading_columns + i * 2 + 1, 2, TAB_CENTER | TAT_TITLE,
_ ("Percent"));
tab_joint_text (tbl, heading_columns + i*2 , 1,
- heading_columns + i*2 + 1, 1,
+ heading_columns + i * 2 + 1, 1,
TAB_CENTER | TAT_TITLE,
subtitle[i]);
tab_box (tbl, -1, -1,
TAL_0, TAL_0,
- heading_columns + i*2, 1,
- heading_columns + i*2 + 1, 1);
-
+ heading_columns + i * 2, 1,
+ heading_columns + i * 2 + 1, 1);
}
tab_text (tbl, 2, heading_rows - 1, TAB_CENTER | TAT_TITLE,
var_to_string (fctr->indep_var[1]));
}
-
}
if ( fctr )
n_factors = hsh_count (fctr->fstats);
-
if ( i > 0 )
tab_hline (tbl, TAL_1, 0, n_cols -1 , i * n_factors + heading_rows);
var_to_string (dependent_var[i])
);
-
if ( !fctr )
populate_summary (tbl, heading_columns,
(i * n_factors) + heading_rows,
&totals[i]);
-
-
else
{
struct factor_statistics **fs = fctr->fs;
if (fctr->indep_var[1] && count > 0 )
tab_hline (tbl, TAL_1, 1, n_cols - 1,
(i * n_factors ) + count + heading_rows);
-
}
prev = (*fs)->id[0];
ds_init_empty (&vstr);
var_append_value_name (fctr->indep_var[1],
(*fs)->id[1], &vstr);
- tab_text (tbl,
- 2,
- (i * n_factors ) + count +
- heading_rows,
- TAB_LEFT | TAT_TITLE,
+ tab_text (tbl,
+ 2,
+ (i * n_factors ) + count +
+ heading_rows,
+ TAB_LEFT | TAT_TITLE,
ds_cstr (&vstr)
- );
+ );
ds_destroy (&vstr);
- }
+ }
populate_summary (tbl, heading_columns,
- (i * n_factors) + count
- + heading_rows,
- & (*fs)->m[i]);
+ (i * n_factors) + count
+ + heading_rows,
+ & (*fs)->m[i]);
count++ ;
fs++;
/* This seems a bit pointless !!! */
tab_text (t, col + 5, row + 0, TAB_RIGHT | TAT_PRINTF, "%2.0f%%",
100.0 * total / total );
-
-
}
-
-
}
--- /dev/null
+#!/bin/sh
+
+# This program tests for a bug in which examine didn't
+# count missing values.
+
+TEMPDIR=/tmp/pspp-tst-$$
+TESTFILE=$TEMPDIR/`basename $0`.sps
+
+# ensure that top_srcdir and top_builddir are absolute
+if [ -z "$top_srcdir" ] ; then top_srcdir=. ; fi
+if [ -z "$top_builddir" ] ; then top_builddir=. ; fi
+top_srcdir=`cd $top_srcdir; pwd`
+top_builddir=`cd $top_builddir; pwd`
+
+PSPP=$top_builddir/src/ui/terminal/pspp
+
+STAT_CONFIG_PATH=$top_srcdir/config
+export STAT_CONFIG_PATH
+
+LANG=C
+export LANG
+
+
+cleanup()
+{
+ if [ x"$PSPP_TEST_NO_CLEANUP" != x ] ; then
+ echo "NOT cleaning $TEMPDIR"
+ return ;
+ fi
+ rm -rf $TEMPDIR
+}
+
+
+fail()
+{
+ echo $activity
+ echo FAILED
+ cleanup;
+ exit 1;
+}
+
+
+no_result()
+{
+ echo $activity
+ echo NO RESULT;
+ cleanup;
+ exit 2;
+}
+
+pass()
+{
+ cleanup;
+ exit 0;
+}
+
+mkdir -p $TEMPDIR
+
+cd $TEMPDIR
+
+activity="create program"
+cat > $TESTFILE << EOF
+DATA LIST LIST /x * y *.
+BEGIN DATA.
+1 1
+2 1
+3 1
+4 1
+5 2
+6 2
+. 2
+END DATA
+
+EXAMINE /x by y.
+EOF
+if [ $? -ne 0 ] ; then no_result ; fi
+
+
+activity="run program"
+$SUPERVISOR $PSPP --testing-mode -o raw-ascii $TESTFILE
+if [ $? -ne 0 ] ; then no_result ; fi
+
+activity="compare results"
+perl -pi -e 's/^\s*$//g' $TEMPDIR/pspp.list
+diff -b $TEMPDIR/pspp.list - <<EOF
+1.1 DATA LIST. Reading free-form data from INLINE.
++--------+------+
+|Variable|Format|
+#========#======#
+|x |F8.0 |
+|y |F8.0 |
++--------+------+
+2.1 EXAMINE. Case Processing Summary
+#=#=============================#
+# # Cases #
+# #---------+---------+---------#
+# # Valid | Missing | Total #
+# #-+-------+-+-------+-+-------#
+# #N|Percent|N|Percent|N|Percent#
+#=#=#=======#=#=======#=#=======#
+#x#6| 86%|1| 14%|7| 100%#
+#=#=#=======#=#=======#=#=======#
+2.2 EXAMINE. Case Processing Summary
+#==========#=============================#
+# # Cases #
+# #---------+---------+---------#
+# # Valid | Missing | Total #
+# #-+-------+-+-------+-+-------#
+# y #N|Percent|N|Percent|N|Percent#
+#==========#=#=======#=#=======#=#=======#
+#x 1.00#4| 100%|0| 0%|4| 100%#
+# 2.00#2| 67%|1| 33%|3| 100%#
+#==========#=#=======#=#=======#=#=======#
+EOF
+if [ $? -ne 0 ] ; then fail ; fi
+
+pass;